// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#define TestTrace_Classes_Package_A1_Package_C1_C1_BODY

/************************************************************
 C1 class body
 ************************************************************/

// include associated header file
#include "TestTrace/Classes/Package_A1/Package_C1/C1.h"

// Derived includes directives
#include "TestTrace/Interfaces/I_MyInterface_1.h"
#include "TestTrace/Signals/Sig_MyOperation_1.h"
#include "barectf/classes/BareCTFInit.h"
#include "ctf/barectf.h"
#include "statemachine/Event_t.h"
#include "statemachine/Pkg_statemachine.h"

// Derived using namespaces
using namespace TestTrace::Interfaces;
using namespace TestTrace::Signals;
using namespace barectf::classes;
using namespace statemachine;
namespace TestTrace {
namespace Classes {
namespace Package_A1 {
namespace Package_C1 {

// static attributes (if any)

/**
 * 
 */
void C1::dispatchEvent() {
	bool popDeferred = false;
	while (true) {
		//run-to-completion: need to have a mutex here
		currentEvent = eventQueue.pop(popDeferred);
		dispatchFlag = true;
		if (currentEvent != NULL) {
			unsigned int eventID = currentEvent->eventID;
			C1_GET_CONTROL
			switch (eventID) {
			case EV_MYOPERATION_1_ID: {
				::TestTrace::Signals::Sig_MyOperation_1 sig_EV_MYOPERATION_1_ID;
				if (currentEvent != NULL) {
					memcpy(&sig_EV_MYOPERATION_1_ID, currentEvent->data,
							sizeof(::TestTrace::Signals::Sig_MyOperation_1));
					processEv_MyOperation_1(sig_EV_MYOPERATION_1_ID);
				}
				break;
			}
			case COMPLETIONEVENT_ID: {
				processCompletionEvent();
				break;
			}
			}
			if (systemState
					== statemachine::SystemStateEnum_t::EVENT_DEFERRED) {
				eventQueue.saveDeferred(*currentEvent);
			}
			popDeferred = (systemState
					!= statemachine::SystemStateEnum_t::EVENT_DEFERRED);
			systemState = statemachine::SystemStateEnum_t::IDLE;
			C1_RELEASE_CONTROL
		}
		usleep(100);
	}
}

/**
 * 
 * @param state 
 */
void C1::MyOperation_1(BooleanType /*in*/state) {
	barectf_default_trace_port_op_starts_C1_listening_MyOperation_1_00000(
			BareCTFInit::ctx(), instanceName);
	std::cout << "Reception in C1" << std::endl;

	Sig_MyOperation_1 SIG_MY_OPERATION_1;
	sendEv_MyOperation_1(SIG_MY_OPERATION_1);

}

/**
 * 
 * @param enter_mode 
 */
void C1::StateMachine_Region1_Enter(char /*in*/enter_mode) {
	switch (enter_mode) {
	case STATEMACHINE_REGION1_DEFAULT:
		activeStateID = FIRSTSTATE_ID;

		(this->*states[FIRSTSTATE_ID].entry)();
		//starting the counters for time events

		//TODO: set systemState to EVENT_CONSUMED
		break;
	}
}

/**
 * 
 */
C1::C1() {
	startBehavior();
}

/**
 * 
 */
void C1::startBehavior() {
	systemState = statemachine::SystemStateEnum_t::IDLE;
	states[FIRSTSTATE_ID].entry = &C1::FirstState_entry;
	states[FIRSTSTATE_ID].exit = &C1::FirstState_exit;
	doActivityTable[FIRSTSTATE_ID] = states[FIRSTSTATE_ID].doActivity;
	states[SECONDSTATE_ID].entry = &C1::SecondState_entry;
	doActivityTable[SECONDSTATE_ID] = states[SECONDSTATE_ID].doActivity;

	// initialize all threads, the threads wait until the associated flag is set
	for (int i = 0; i < (int) STATE_MAX; i++) {
		if (states[i].doActivity != &C1::doActivity_dft) {
			threadStructs[i].id = i;
			threadStructs[i].ptr = this;
			threadStructs[i].func_type =
					statemachine::ThreadFunctions::TF_DO_ACTIVITY;
			mutexes[i] = PTHREAD_MUTEX_INITIALIZER;
			conds[i] = PTHREAD_COND_INITIALIZER;
			pthread_create(&threads[i], NULL, &C1::thread_func_wrapper,
					&threadStructs[i]);
		}
	}

	runToCompletionMutex = PTHREAD_MUTEX_INITIALIZER;
	runToCompletionCond = PTHREAD_COND_INITIALIZER;

	dispatchStruct = statemachine::StructForThread_t(this, 0, 0,
			statemachine::ThreadFunctions::TF_STATE_MACHINE_TYPE, 0);
	C1_THREAD_CREATE(dispatchThread, dispatchStruct)
	while (!dispatchFlag) {
		usleep(100);
	}

	//initialze root active state
	//execute initial effect
	StateMachine_Region1_Enter (STATEMACHINE_REGION1_DEFAULT);
}

/**
 * 
 * @param sig 
 */
void C1::processEv_MyOperation_1(Sig_MyOperation_1 & /*in*/sig) {
	systemState = statemachine::SystemStateEnum_t::EVENT_PROCESSING;
	if (systemState == statemachine::SystemStateEnum_t::EVENT_PROCESSING) {
		switch (activeStateID) {
		case FIRSTSTATE_ID:
			//from FirstState to SecondState
			if (true) {
				//exit action of FirstState
				(this->*states[FIRSTSTATE_ID].exit)();
				std::cout << "Start effect external transition C1" << std::endl;
				index = index + 1;
				std::cout << "Finish effect external transition C1"
						<< std::endl;
				activeStateID = SECONDSTATE_ID;
				(this->*states[SECONDSTATE_ID].entry)();
				//starting the counters for time events
				systemState = statemachine::SystemStateEnum_t::EVENT_CONSUMED;
			}
			break;
		default:
			//do nothing
			break;
		}
	}
}

/**
 * 
 * @param sig 
 */
void C1::sendEv_MyOperation_1(Sig_MyOperation_1 & /*in*/sig) {
	eventQueue.push(statemachine::EventPriority_t::PRIORITY_2, &sig,
			EV_MYOPERATION_1_ID, statemachine::EventType_t::SIGNAL_EVENT, 0,
			sizeof(::TestTrace::Signals::Sig_MyOperation_1));
}

/**
 * 
 */
void C1::processCompletionEvent() {
	systemState = statemachine::SystemStateEnum_t::EVENT_PROCESSING;
}

/**
 * 
 */
void C1::FirstState_entry() {
	std::cout << "Start entry from state FirstState in C1" << std::endl;
	index = 0;
	std::cout << "Finish entry from state FirstState in C1" << std::endl;
}

/**
 * 
 */
void C1::FirstState_exit() {
	std::cout << "Start exit from state FirstState in C1" << std::endl;
	index = index + 1;
	std::cout << "Finish exit from state FirstState in C1" << std::endl;
}

/**
 * 
 */
void C1::SecondState_entry() {
	std::cout << "Start entry from state SecondState in C1" << std::endl;
	index = index + 1;
	std::cout << "Finish entry from state SecondState in C1" << std::endl;
}

/**
 * 
 * @param data 
 * @return ret 
 */
void* C1::thread_func_wrapper(void * /*in*/data) {
	statemachine::StructForThread_t *cptr =
			(statemachine::StructForThread_t*) data;
	C1 *ptr = (C1*) cptr->ptr;
	switch (cptr->func_type) {
	case statemachine::ThreadFunctions::TF_STATE_MACHINE_TYPE:
		ptr->dispatchEvent();
		break;
	default:
		// do nothing
		break;
	}
	return NULL;
}

/**
 * 
 * @param id 
 */
void C1::doCallActivity(int /*in*/id) {
	flags[id] = false;
	while (true) {
		pthread_mutex_lock (&mutexes[id]);
		while (!flags[id]) {
			pthread_cond_wait(&conds[id], &mutexes[id]);
		}
		(this->*doActivityTable[id])();
		if (flags[id]) {
			flags[id] = false;
		}
		pthread_cond_signal (&conds[id]);
		pthread_mutex_unlock(&mutexes[id]);
	}
}

/**
 * 
 * @param id 
 * @param func_type 
 * @param value 
 */
void C1::setFlag(int /*in*/id, ThreadFunctions /*in*/func_type,
		bool /*in*/value) {
	//value = true => start activity
	//value = false => stop activity
	if (func_type == statemachine::ThreadFunctions::TF_DO_ACTIVITY) {
	}
}

/**
 * 
 */
void C1::entry_dft() {
}

/**
 * 
 */
void C1::exit_dft() {
}

/**
 * 
 */
void C1::doActivity_dft() {
}

/**
 * 
 * @return ret 
 */
I_MyInterface_1* C1::get_listeningI_MyInterface_1() {
	return this;
}

} // of namespace Package_C1
} // of namespace Package_A1
} // of namespace Classes
} // of namespace TestTrace

/************************************************************
 End of C1 class body
 ************************************************************/
